<?php
/********************************* PHP-P10 ******************************
 *    P10 uplink class by pk910   (c)2011 pk910                         *
 ************************************************************************
 *                          Version 2 (OOP)                             *
 *                                                                      *
 * PHP-P10 is free software; you can redistribute it and/or modify      *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with PHP-P10; if not, write to the Free Software Foundation,   *
 * Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.       *
 *                                                                      *
 ************************************************************************
 * 
 *  main.php
 *
 * initial php file
 *
 */
declare(ticks = 1);
error_reporting(E_ALL & ~E_STRICT);

require_once("Uplink/Uplink.class.php");
require_once("ModCMD/ModCMD.class.php");
require_once("BotLoader/BotLoader.class.php");
require_once("Tools/timer.inc.php");

if(function_exists("pcntl_signal")) {
	pcntl_signal(SIGINT, 'shutdown');
	pcntl_signal(SIGTERM, 'shutdown');
}

//basicly here is nothing, yet :D
$uplink = new Uplink();
require_once("config.inc.php");

$uplink->setEventHandler(ModCMD::getEventHandler());

$uplink->initialize();

$botloader = new BotLoader($uplink);
$botloader->loadBots();
BotLoader::load("ModManager", "ModManager.class.php");

function shutdown($signal = 0) {
	global $botloader;
	global $uplink;
	echo "\n\nrecived shutdown instruction...\n";
	$botloader->unloadBots();
	$botloader->save();
	$uplink->shutdown();
	exit;
}

while(true) {
	$uplink->loop();
	$botloader->loop();
	timer_loop();
	if(function_exists("pcntl_signal_dispatch"))
		pcntl_signal_dispatch();
}

?>